VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Prueba de impresin"
   ClientHeight    =   6645
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5970
   Icon            =   "HTP250.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   6645
   ScaleWidth      =   5970
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command3 
      Caption         =   "&Cajn"
      Height          =   495
      Left            =   1680
      TabIndex        =   7
      Top             =   6000
      Width           =   1215
   End
   Begin VB.PictureBox Picture1 
      Height          =   855
      Left            =   120
      Picture         =   "HTP250.frx":08CA
      ScaleHeight     =   795
      ScaleWidth      =   5715
      TabIndex        =   6
      Top             =   120
      Width           =   5775
   End
   Begin VB.CommandButton Command2 
      Caption         =   "&Salir"
      Height          =   495
      Left            =   4560
      TabIndex        =   5
      Top             =   6000
      Width           =   1215
   End
   Begin VB.ComboBox Combo1 
      Height          =   315
      Left            =   240
      TabIndex        =   2
      Text            =   "Combo1"
      Top             =   1680
      Width           =   5415
   End
   Begin VB.CommandButton Command1 
      Caption         =   "&Imprimir"
      Height          =   495
      Left            =   3120
      TabIndex        =   1
      Top             =   6000
      Width           =   1215
   End
   Begin VB.TextBox Text1 
      Height          =   2295
      Left            =   480
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Text            =   "HTP250.frx":1C6C
      Top             =   3000
      Width           =   4335
   End
   Begin VB.Frame Frame1 
      Caption         =   "Lista de impresoras"
      Height          =   1215
      Left            =   120
      TabIndex        =   3
      Top             =   1200
      Width           =   5775
   End
   Begin VB.Frame Frame2 
      Caption         =   "Texto a imprimir"
      Height          =   2895
      Left            =   120
      TabIndex        =   4
      Top             =   2640
      Width           =   5055
   End
   Begin VB.Line Line1 
      BorderColor     =   &H80000010&
      X1              =   120
      X2              =   5880
      Y1              =   5760
      Y2              =   5760
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Option Explicit

Const APPNAME = "Impresora No Fiscal"
Const PRINTER_ENUM_LOCAL = &H2

Dim lhPrinter As Long

Private Type PRINTER_INFO_1
    flags As Long
    pDescription As String
    pName As String
    pComment As String
End Type

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
    (ByVal hWnd As Long, ByVal wMsg As Long, _
    ByVal wParam As Long, ByVal lParam As Long) As Long
Private Sub ImprimirPorLinea(qControl As TextBox)
'    Dim lhPrinter As Long
    Dim lReturn As Long
    Dim lpcWritten As Long
    Dim lDoc As Long
    Dim sWrittenData As String
    'Dim MyDocInfo As DOCINFO

    Dim i As Long, k As Long
    Dim L1 As Long, L2 As Long
    
    Const EM_GETLINECOUNT = &HBA
    Const EM_LINEFROMCHAR = &HC9
    Const EM_LINELENGTH = &HC1
    Const EM_LINEINDEX = &HBB
    
    On Error GoTo ErrImpresora
    
Procesar:
  
    ' Obtenemos el Nmero de lneas del TextBox
    k = SendMessage(qControl.hWnd, EM_GETLINECOUNT, 0, 0&)
 
    For i = 0 To k - 1
        L1 = SendMessage(qControl.hWnd, EM_LINEINDEX, i, 0&) + 1
        L2 = SendMessage(qControl.hWnd, EM_LINELENGTH, L1, 0&)
        ' Imprimir texto
        sWrittenData = Mid$(qControl.Text, L1, L2) & vbLf ' & vbFormFeed
        'sWrittenData = "hola" & vbLf ' vbFormFeed
        lReturn = WritePrinter(lhPrinter, ByVal sWrittenData, _
        Len(sWrittenData), lpcWritten)
    Next
    
    ' Avanzar 5 lneas
    sWrittenData = Chr$(27) & Chr$(100) & Chr$(5)
    lReturn = WritePrinter(lhPrinter, ByVal sWrittenData, Len(sWrittenData), lpcWritten)
        
    ' Cortar papel
    sWrittenData = Chr$(27) & Chr$(109) & Chr$(0)
    lReturn = WritePrinter(lhPrinter, ByVal sWrittenData, Len(sWrittenData), lpcWritten)
    
    Exit Sub
    
ErrImpresora:
    MsgBox "Error en Impresora", vbCritical, APPNAME
    
End Sub

Private Sub Command1_Click()
    If Text1 = "" Then
        MsgBox "La caja de texto est vaca.", vbExclamation, APPNAME
        Exit Sub
    End If
    If AbrirImpresora() Then
        Call ImprimirPorLinea(Text1)
        CerrarImpresora
    End If
End Sub

Private Sub Command2_Click()
    Unload Me
End Sub

Private Sub Command3_Click()
    Dim sWrittenData As String
    Dim lpcWritten As Long
    Dim lReturn As Long
    
    If AbrirImpresora() Then
        sWrittenData = Chr$(27) & Chr$(112) & Chr$(0) & Chr$(10) & Chr$(10)
        lReturn = WritePrinter(lhPrinter, ByVal sWrittenData, Len(sWrittenData), lpcWritten)
        CerrarImpresora
    End If

End Sub

Private Sub Form_Load()

    Dim longbuffer() As Long  ' resizable array receives information from the function
    Dim printinfo() As PRINTER_INFO_1  ' values inside longbuffer() will be put into here
    Dim numbytes As Long  ' size in bytes of longbuffer()
    Dim numneeded As Long  ' receives number of bytes necessary if longbuffer() is too small
    Dim numprinters As Long  ' receives number of printers found
    Dim c As Integer, retval As Long  ' counter variable & return value
    
    ' Get information about the local printers
    numbytes = 3076  ' should be sufficiently big, but it may not be
    ReDim longbuffer(0 To numbytes / 4) As Long  ' resize array -- note how 1 Long = 4 bytes
    retval = EnumPrinters(PRINTER_ENUM_LOCAL, "", 1, longbuffer(0), numbytes, numneeded, numprinters)
    If retval = 0 Then  ' try enlarging longbuffer() to receive all necessary information
        numbytes = numneeded
        ReDim longbuffer(0 To numbytes / 4) As Long  ' make it large enough
        retval = EnumPrinters(PRINTER_ENUM_LOCAL, "", 1, longbuffer(0), numbytes, numneeded, numprinters)
        If retval = 0 Then ' failed again!
            MsgBox "No se pudo levantar las impresoras disponibles en el sistema.", vbExclamation, APPNAME
            'Debug.Print "Could not successfully enumerate the printes."
        End  ' abort program
    End If
    End If
    ' Convert longbuffer() data into printinfo()
    If numprinters <> 0 Then ReDim printinfo(0 To numprinters - 1) As PRINTER_INFO_1 ' room for each printer
    For c = 0 To numprinters - 1  ' loop, putting each set of information into each element
        ' longbuffer(4 * c) = .flags, longbuffer(4 * c + 1) = .pDescription, etc.
        ' For each string, the string is first buffered to provide enough room, and then the string is copied.
        printinfo(c).flags = longbuffer(4 * c)
        printinfo(c).pDescription = Space(lstrlen(longbuffer(4 * c + 1)))
        retval = lstrcpy(printinfo(c).pDescription, longbuffer(4 * c + 1))
        printinfo(c).pName = Space(lstrlen(longbuffer(4 * c + 2)))
        retval = lstrcpy(printinfo(c).pName, longbuffer(4 * c + 2))
        printinfo(c).pComment = Space(lstrlen(longbuffer(4 * c + 3)))
        retval = lstrcpy(printinfo(c).pComment, longbuffer(4 * c + 3))
    Next c
    ' Display name of each printer
    For c = 0 To numprinters - 1
        'Me.Print "Name of printer"; c + 1; " is: "; printinfo(c).pName
        Combo1.AddItem printinfo(c).pName
    Next c
    
    If Combo1.ListCount Then Combo1.ListIndex = 0
End Sub

Private Function AbrirImpresora() As Boolean
    Dim lReturn As Long
    Dim MyDocInfo As DOCINFO
    Dim lDoc As Long
    
    AbrirImpresora = False
    lReturn = OpenPrinter(Combo1.Text, lhPrinter, 0)
    If lReturn = 0 Then
        MsgBox "Impresora no reconocida.", vbExclamation, APPNAME
        Exit Function
    End If
    
    MyDocInfo.pDocName = "HasarPruebaDeImpresion"
    MyDocInfo.pOutputFile = vbNullString
    MyDocInfo.pDatatype = vbNullString
    lDoc = StartDocPrinter(lhPrinter, 1, MyDocInfo)
    Call StartPagePrinter(lhPrinter)
    AbrirImpresora = True
    Exit Function
    
End Function

Private Sub CerrarImpresora()
    Dim lReturn As Long
    
    lReturn = EndPagePrinter(lhPrinter)
    lReturn = EndDocPrinter(lhPrinter)
    lReturn = ClosePrinter(lhPrinter)

End Sub

