VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3090
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3090
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox Offline 
      Caption         =   "Fuera de lnea"
      Height          =   255
      Left            =   240
      TabIndex        =   9
      Top             =   2640
      Width           =   2535
   End
   Begin VB.CheckBox MechanicalError 
      Caption         =   "Error mecnico"
      Height          =   255
      Left            =   240
      TabIndex        =   8
      Top             =   2400
      Width           =   2535
   End
   Begin VB.CheckBox DrawerOpen 
      Caption         =   "Cajn abierto"
      Height          =   255
      Left            =   240
      TabIndex        =   7
      Top             =   2160
      Width           =   2535
   End
   Begin VB.CheckBox CoverOpen 
      Caption         =   "Tapa abierta"
      Height          =   255
      Left            =   240
      TabIndex        =   6
      Top             =   1920
      Width           =   2535
   End
   Begin VB.CheckBox ReceiptEnd 
      Caption         =   "Falta papel"
      Height          =   255
      Left            =   240
      TabIndex        =   5
      Top             =   1680
      Width           =   2535
   End
   Begin VB.CheckBox JournalEnd 
      Caption         =   "Falta papel (rollo auditora)"
      Height          =   255
      Left            =   240
      TabIndex        =   4
      Top             =   1440
      Width           =   2535
   End
   Begin VB.CheckBox ReceiptNearEnd 
      Caption         =   "Poco papel"
      Height          =   255
      Left            =   240
      TabIndex        =   3
      Top             =   1200
      Width           =   2535
   End
   Begin VB.CheckBox JournalNearEnd 
      Caption         =   "Poco papel (rollo auditora)"
      Height          =   255
      Left            =   240
      TabIndex        =   2
      Top             =   960
      Width           =   2535
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   2040
      Top             =   1320
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Default         =   -1  'True
      Height          =   495
      Left            =   2880
      TabIndex        =   1
      Top             =   240
      Width           =   1215
   End
   Begin VB.TextBox Text1 
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Text            =   "Text1"
      Top             =   240
      Width           =   2535
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private StateCounter As Integer
Private PrinterStatus(4) As Byte
Private Enum FirstStatusByte  ' Printer information
        BIT_DRAWER = 2
        BIT_ONLINE = 3
        BIT_COVER = 5
        BIT_PAPER_FED = 6
End Enum

Private Enum SecondStatusByte  ' Error information
        BIT_MECHANICAL_ERROR = 2
        BIT_AUTOCUTTER_ERROR = 3
        BIT_UNRECOVERABLE_ERROR = 5
        BIT_TEMPERATURE_ERROR = 6
End Enum

Private Enum ThirdStatusByte ' Paper sensor information
        BIT_JOURNAL_NEAR_END = 0
        BIT_RECEIPT_NEAR_END = 1
        BIT_JOURNAL_END = 2
        BIT_RECEIPT_END = 3
End Enum

Private Sub Command1_Click()
    MSComm1.Output = Text1.Text & vbLf
End Sub

Private Sub Form_Load()
    MSComm1.CommPort = 3
    MSComm1.Handshaking = comXOnXoff
    MSComm1.Settings = "115200,n,8,1"
    MSComm1.EOFEnable = False
    MSComm1.InputLen = 1
    MSComm1.RThreshold = 1
    MSComm1.PortOpen = True
    
    'Reset: ESC @
    MSComm1.Output = Chr(27) & "@"
    'Autostatus: GS 'a' 2fh
    MSComm1.Output = Chr(29) & "a" & Chr(47)
    
    Text1 = ""
    
End Sub

Private Function IsBit(ByVal n As Long, ByVal Bit As Long) As Boolean
    Dim Mask As Long
    Mask = 2 ^ Bit
    IsBit = (n And Mask) = Mask
End Function

Private Sub ParseStatus(ByVal b As Long)

    Select Case (StateCounter)
        Case 0:
            'Valores fijos de este byte:
            'Bit0 = 0  Bit1 = 0
            'Bit4 = 1  Bit7 = 0
            If Not IsBit(b, 0) And Not IsBit(b, 1) And IsBit(b, 4) Then
                PrinterStatus(StateCounter) = b
                StateCounter = StateCounter + 1
            End If
        Case 1:
            'Valores fijos de este byte:
            'Bit4 = 0  Bit7 = 0

            If IsBit(b, 4) Or IsBit(b, 7) Then
                StateCounter = 0
                Exit Sub
            End If
            PrinterStatus(StateCounter) = b
            StateCounter = StateCounter + 1
        Case 2:
            'Valores fijos de este byte:
            'Bit4 = 0
            'Bit7 = 0

            If IsBit(b, 4) Or IsBit(b, 7) Then
                StateCounter = 0
                Exit Sub
            End If
            PrinterStatus(StateCounter) = b
            StateCounter = StateCounter + 1
        Case 3:
            'Valores fijos de este byte:
            'Bit4 = 0
            'Bit7 = 0

            If IsBit(b, 4) Or IsBit(b, 7) Then
                StateCounter = 0
                Exit Sub
            End If
            PrinterStatus(StateCounter) = b
            StateCounter = 0
            
            JournalNearEnd = IIf(IsBit(PrinterStatus(2), BIT_JOURNAL_NEAR_END), vbChecked, vbUnchecked)
            ReceiptNearEnd = IIf(IsBit(PrinterStatus(2), BIT_RECEIPT_NEAR_END), vbChecked, vbUnchecked)
            JournalEnd = IIf(IsBit(PrinterStatus(2), BIT_JOURNAL_END), vbChecked, vbUnchecked)
            ReceiptEnd = IIf(IsBit(PrinterStatus(2), BIT_RECEIPT_END), vbChecked, vbUnchecked)
            CoverOpen = IIf(IsBit(PrinterStatus(0), BIT_COVER), vbChecked, vbUnchecked)
            DrawerOpen = IIf(IsBit(PrinterStatus(0), BIT_DRAWER), vbChecked, vbUnchecked)
            MechanicalError = IIf(IsBit(PrinterStatus(1), BIT_AUTOCUTTER_ERROR) Or _
                IsBit(PrinterStatus(1), BIT_MECHANICAL_ERROR) Or _
                IsBit(PrinterStatus(1), BIT_UNRECOVERABLE_ERROR) Or _
                IsBit(PrinterStatus(1), BIT_TEMPERATURE_ERROR), vbChecked, vbUnchecked)
            Offline = IIf(IsBit(PrinterStatus(0), BIT_ONLINE), vbChecked, vbUnchecked)
    End Select

End Sub


Private Sub MSComm1_OnComm()
    Select Case MSComm1.CommEvent
        Case comEvReceive:
            Dim i As Integer
            Dim s As String
            s = MSComm1.Input
            For i = 1 To Len(s)
                ParseStatus Asc(Mid$(s, i, 1))
            Next
        Case comEvDSR:

        Case Else:

    End Select
End Sub


